state_play = newState({100/255, 100/255, 100/255})

local score = 0
local score_y = 545
local counter = 0
local font = love.graphics.newFont(20)
local box_size = 46

function state_play.load()
  score = 0
  box_size = 46
  player.initialize()
  score_y = cell.initialize(box_size, 'WASD or ARROWS')
end

function state_play.update(dt)
  counter = counter + dt
  if counter >= 1 then
    score = score + 1
    counter = 0
  end

  player.update(dt)
  cell.update(dt)
  
    if player.y - player.size / 2 < cell.walls['up'][1].y + wall_size then
      player.y = cell.walls['up'][1].y + wall_size + player.size / 2
    end
    if player.y + player.size / 2 > cell.walls['down'][1].y then
      player.y = cell.walls['down'][1].y - player.size / 2
    end
    if player.x - player.size / 2 < cell.walls['left'][1].x + wall_size then
      player.x = cell.walls['left'][1].x + wall_size + player.size / 2
    end
    if player.x + player.size / 2 > cell.walls['right'][1].x then
      player.x = cell.walls['right'][1].x - player.size / 2
    end
  
  -- If player has touched a Laser
  for _, v in pairs(cell.lasers) do
    if getCircleRectangleDistance(player.x, player.y, player.size / 2, v.x, v.y, v.w, v.h) < 0 and v.life > 0.5 then
      state_machine.push(state_gameover, score)
    end
  end
  
  -- If the cell has had enough, shrink!
  if cell.ready_to_initialize then
    box_size = box_size - 2
    score_y = cell.initialize(box_size)
  end
end

function state_play.draw()
  player.draw()
  cell.draw()
  love.graphics.setFont(font)
  love.graphics.setColor(0,0,0)
  love.graphics.printf('Score:\n' .. score, 0, score_y, love.graphics.getWidth(), 'center')
end

function state_play.keypressed(key)
  if key == 'escape' then
    state_machine.push(state_pause)
  end
end
