state_title = newState({100/255, 100/255, 100/255})

local menu = newMenu(love.graphics.newFont(40), 10)
local font = love.graphics.newFont(100)
local text = 'LASER CELL'
local lasers = {}
local lasers_thinktime = 2
local laser1_think = 0
local laser2_think = 0

menu.addButton('Play', love.graphics.getWidth() / 2, 300,
  function()
    state_machine.change(state_play)
  end
)
menu.addButton('High Scores', love.graphics.getWidth() / 2, 400,
  function()
    state_machine.change(state_highscores, false)
  end
)
menu.addButton('Exit', love.graphics.getWidth() / 2, 500,
  function()
    love.event.quit()
  end
)

function state_title.load(params)
  laser1_think = 1 -- Horizontal Laser
  laser2_think = 0 -- Vertical Laser
  lasers = {}
end
function state_title.update(dt)
  laser1_think = laser1_think + dt
  if laser1_think >= lasers_thinktime then
    laser1_think = love.math.random(0, 1) + dt
    local y = love.math.random(love.graphics.getHeight() - wall_size)
    table.insert(lasers, newLaser(0, y, love.graphics.getWidth(), wall_size))    
  end
  
  laser2_think = laser2_think + dt
  if laser2_think >= lasers_thinktime then
    laser2_think = love.math.random(0, 1) + dt
    local x = love.math.random(love.graphics.getWidth() - wall_size)
    table.insert(lasers, newLaser(x, 0, wall_size, love.graphics.getHeight()))
  end

  local laser_killer = {}
  for i, v in ipairs(lasers) do
    if v.life <= 0 then table.insert(laser_killer, i) end
    v.update(dt)
  end
  for i = #laser_killer, 1, -1 do
    table.remove(lasers, laser_killer[i])
  end
  
end
function state_title.draw()
  for _, v in pairs(lasers) do
    v.draw()
  end
  love.graphics.setColor(1,1,1)
  love.graphics.setFont(font)
  love.graphics.printf('Laser Cell', 0, 50, love.graphics.getWidth(), 'center')
  menu.draw()
end

function state_title.keypressed(key)
  if key == 'return' or key == 'space' then
    menu.button_press()
  elseif key == 'left' or key == 'up' then
    menu.cycle_up()
  elseif key == 'right' or key == 'down' then
    menu.cycle_down()
  end
end
function state_title.keyreleased(key)
  if key == 'return' or key == 'space' then
    menu.button_release()
  end
end

function state_title.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
end
function state_title.mousepressed(x, y, button)
  if button == 1 then menu.button_press() end
end
function state_title.mousereleased(x, y, button)
  if button == 1 then menu.button_release() end
end
