wall_size = 10

local charge = love.audio.newSource('sfx/charge.wav', 'static')
local shoot = love.audio.newSource('sfx/shoot.mp3', 'static')

local firerate = 1
local defcolor = {0, 100/255, 0}

function newWall(x, y, laser_x, laser_y, laser_w, laser_h)
  local wall = { x = x, y = y , firing = false, firetime = firerate}
  
  function wall.draw()
    local color = wall.firing and {1, (wall.firetime * 255)/255, 0} or defcolor
    love.graphics.setColor(color)
    love.graphics.rectangle('fill', wall.x, wall.y, wall_size, wall_size)
  end
  
  function wall.fire_laser()
    wall.firing = false
    wall.firetime = 1
    shoot:stop() shoot:play()
  end
  
  function wall.newLaser()
    return newLaser(laser_x, laser_y, laser_w, laser_h)
  end
  
  function wall.charge_up()
    wall.firing = true
    charge:stop()
    charge:play()
  end
  
  return wall
end